function varargout = TxFt(varargin)
% TXFT MATLAB code for TxFt.fig
%      TXFT, by itself, creates a new TXFT or raises the existing
%      singleton*.
%
%      H = TXFT returns the handle to a new TXFT or the handle to
%      the existing singleton*.
%
%      TXFT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TXFT.M with the given input arguments.
%
%      TXFT('Property','Value',...) creates a new TXFT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TxFt_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TxFt_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TxFt

% Last Modified by GUIDE v2.5 13-Apr-2016 17:13:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TxFt_OpeningFcn, ...
                   'gui_OutputFcn',  @TxFt_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before TxFt is made visible.
function TxFt_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TxFt (see VARARGIN)

% Choose default command line output for TxFt
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using TxFt.
if strcmp(get(hObject,'Visible'),'off')
    plot(rand(5));
end
set(handles.find_tap_coef,'Visible','off');
set(handles.ffe_taps,'Visible','off');
% UIWAIT makes TxFt wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%Load config file if present
if exist('iTx.cfg', 'file')
    load('iTx.cfg','-mat');                       
    set(handles.baudselect,'Value',cfgFile.baudselect);
    set(handles.baud_rate,'String',cfgFile.baud_rate);
    set(handles.d_p,'String',cfgFile.d_p);
    set(handles.N_p,'String',cfgFile.N_p);
    set(handles.addtional_noise,'String',cfgFile.sigma_n);
    set(handles.Nd_p,'String',cfgFile.Nd_p);
    set(handles.makefigs,'Value',cfgFile.makefigs);
    set(handles.sbit,'String',cfgFile.sbit);
    set(handles.nbits,'String',cfgFile.nbits);
    set(handles.trigger_bits,'String',cfgFile.trigger_bits);
    set(handles.trigger,'Value',cfgFile.trigger);
    set(handles.ref_bits,'String',cfgFile.ref_bits);  
    set(handles.coding,'Value',cfgFile.coding);
    set(handles.apply_ctle,'Value',cfgFile.apply_ctle);
    set(handles.apply_ctle_ref,'Value',cfgFile.apply_ctle_ref);
    set(handles.ctle_kacdc,'String',cfgFile.ctle_kacdc);
    set(handles.ctle_fz,'String',cfgFile.ctle_fz);
    set(handles.ctle_fp1,'String',cfgFile.ctle_fp1);
    set(handles.ctle_fp2,'String',cfgFile.ctle_fp2);
    set(handles.ctle_kacdc_ref,'String',cfgFile.ctle_kacdc_ref);
    set(handles.ctle_fz_ref,'String',cfgFile.ctle_fz_ref);
    set(handles.ctle_fp1_ref,'String',cfgFile.ctle_fp1_ref);
    set(handles.ctle_fp2_ref,'String',cfgFile.ctle_fp2_ref);
    if exist(cfgFile.meas_file,'file')
        set(handles.meas_file,'String',cfgFile.meas_file);
    end
    if ~isempty(cfgFile.ref_meas_file) && exist(cfgFile.ref_meas_file,'file')
        set(handles.ref_meas_file,'String',cfgFile.ref_meas_file); %write value to refmeas field
        set(handles.find_tap_coef,'Visible','on'); %make find tap coef visible
        set(handles.ffe_taps,'Visible','on');
    end
end



% --- Outputs from this function are returned to the command line.
function varargout = TxFt_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in fit.
function fit_Callback(hObject, eventdata, handles)
% hObject    handle to fit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.busy_text,'Visible','on')
pause(0.1);  %pause allows busy text to show

params=getappdata(0,'params');
params.SPUI=32;
params.baud_rate=str2num(get(handles.baud_rate,'String'));
params.UI=1/params.baud_rate;
params.coding= get(handles.coding,'Value');
set(handles.UI,'String', sprintf(' %.3g (ps)',params.UI/1e-12));
OP.trigger=get(handles.trigger,'Value');
params.nbits=str2num(get(handles.nbits,'String')); % loop off bits
params.sbit=str2num(get(handles.sbit,'String')); % loop off bits
params.trigger_bits=str2num(get(handles.trigger_bits,'String')); % loop off bits
OP.makefigs=get(handles.makefigs,'Value');

%% Tx Load Meas

%Load Tx measurement if needed
if ~isfield(params,'wf_orig')
    params.meas_file= get(handles.meas_file,'String');
    if isempty(params.meas_file) % RIM 4-11-16
        [elif,mypath]=uigetfile({'*.csv;*.xls;*.xlsx','Excel (*.csv,*.xls,*.xlsx)';'*.mat','Mat (*.mat)'},'Input Measurements ');
        params.meas_file=[mypath elif];
        set(handles.meas_file,'String',params.meas_file);
    end
    [params.path, params.meas_base, params.meas_fileext]=fileparts(params.meas_file);
    params.path = [params.path '\'];
    h=msgbox(['opening... ' params.meas_file ]);
    if strcmp(params.meas_fileext, '.mat')    
         try
            load(params.meas_file) % Must have 2 column called "wf" of time and voltage
         catch
             error('ERROR reading CSV file, file must have 2 columns time and voltage.');
         end
    else    
        wf=csvread(params.meas_file);
    end
    params.wf_orig= wf;  %save copy of original data
    close(h)
else
    params.meas_file= get(handles.meas_file,'String');
    [params.path, params.meas_base, params.meas_fileext]=fileparts(params.meas_file);
    params.path = [params.path '\'];
    h=msgbox(['opening... ' params.meas_file ]);
    if strcmp(params.meas_fileext, '.mat')
        try
            load(params.meas_file) % Must have 2 column called "wf" of time and voltage
        catch
            error('ERROR reading CSV file, file must have 2 columns time and voltage.');
        end
    else
        wf=csvread(params.meas_file);
    end
    params.wf_orig= wf;  %save copy of original data
    close(h)
end

%Setup CTLE
params.apply_ctle = get(handles.apply_ctle,'Value');
if params.apply_ctle
    params.plot_ctle = get(handles.plot_ctle,'Value');
    params.ctle_kacdc = str2num(get(handles.ctle_kacdc,'String'));
    params.ctle_fz = str2num(get(handles.ctle_fz,'String'));
    params.ctle_fp1 = str2num(get(handles.ctle_fp1,'String'));
    params.ctle_fp2 = str2num(get(handles.ctle_fp2,'String'));
else
    params.plot_ctle = 0;
end

%Fit bit pattern
params = fitpat_txmeas(params, params.wf_orig, OP);


%% Tx Load Ref Meas   

if ~isempty(get(handles.ref_meas_file,'String')) %&& isfield(params,'ref_meas_file')  %check if ref measurement exists
    %Load Ref meas if needed
    if ~isfield(params,'wf_orig_ref')
        params.ref_meas_file= get(handles.ref_meas_file,'String');
        [params.ref_path, params.ref_meas_base, params.ref_meas_fileext]=fileparts(params.ref_meas_file);
        params.ref_path = [params.ref_path '\'];
        
        h=msgbox(['opening... ' params.ref_meas_file ]);                      
        if strcmp(params.ref_meas_fileext, '.mat')    
             try
                temp=load(params.ref_meas_file); % Must have 2 column in wf of time and voltage
                wf_ref = temp.wf;
             catch
                error('ERROR reading CSV file, file must have 2 columns time and voltage.');
             end
        else    
            wf_ref=csvread(params.ref_meas_file);
        end
        params.wf_ref_orig = wf_ref;
        close(h);
    end
    
    %Setup CTLE
    params.apply_ctle_ref = get(handles.apply_ctle_ref,'Value');
    if params.apply_ctle_ref
        params.ctle_kacdc_ref = str2num(get(handles.ctle_kacdc_ref,'String'));
        params.ctle_fz_ref = str2num(get(handles.ctle_fz_ref,'String'));
        params.ctle_fp1_ref = str2num(get(handles.ctle_fp1_ref,'String'));
        params.ctle_fp2_ref = str2num(get(handles.ctle_fp2_ref,'String'));
    end    
    
    %Fit Bit pattern
    params= fitpat_txrefmeas(params,params.wf_ref_orig,OP);
    
    %Enable tap coefficent fields
    set(handles.find_tap_coef,'Visible','on');
    set(handles.ffe_taps,'Visible','on');
else
    set(handles.find_tap_coef,'Visible','off');
    set(handles.ffe_taps,'Visible','off');
end

%% FIT 

params.n_p=str2num(get(handles.N_p,'String'));
params.nd_p=str2num(get(handles.Nd_p,'String'));
params.d_p=str2num(get(handles.d_p,'String'));

setappdata(0,'params',params);
[p, linear_fit, e, Y]    =ir_fit_clause_85(params.wf, params.bits, params.UI, params.SPUI, params.n_p,  params.d_p);
[p1, linear_fit1, e1, Y1]=ir_fit_clause_85(params.wf, params.bits, params.UI, params.SPUI, params.nd_p, params.d_p);
params=getappdata(0,'params');

params.p=p;params.linear_fit=linear_fit;params.e=e;params.Y=Y;
params.p1=p1;params.linear_fit1=linear_fit1;params.e=e1;params.Y1=Y1;
%b=repmat([1 zeros(1,params.SPUI-1)],1,params.nd_p);
%s=filter(b,1, p );
%vswing=max(s);
vswing_long=max(cumsum(params.p1/params.SPUI));  %new 03/09/16
vswing=max(cumsum(params.p/params.SPUI));        %new 03/09/16
OP.makefigs=get(handles.makefigs,'Value');
if OP.makefigs
    figure
end
hold off
dt=params.wf.Time(2)-params.wf.Time(1);
t4p=(0:length(p)-1)*dt;
t4p1=(0:length(p1)-1)*dt;
plot(t4p1,p1,'-b','disp','Full PR')
hold on
plot(t4p,p,'-r','disp','Fit')

fbr=timeseries(p,t4p);              %new 03/09/16
fbr1=timeseries(p1,t4p1);           %new 03/09/16
OP.SAVE_TS=0; % add in check box later %new 03/09/16
if OP.SAVE_TS                           %new 03/09/16
    save('fitted_PR.mat',fbr,fbr1);     %new 03/09/16
end


cur=find(p == max(p));
%stem(t4p(cur+params.SPUI*(-params.d_p:params.n_p-params.d_p-1)),p(cur+params.SPUI*(-params.d_p:params.n_p-params.d_p-1)))
stem(t4p(cur+params.SPUI*(-params.d_p:params.n_p-1-params.d_p)),p(cur+params.SPUI*(-params.d_p:params.n_p-1-params.d_p)),'disp','N_p')

grid on
hold off
e=e(1:end-params.SPUI*2);

%sigma_e_mv=rms(e)*1000;
sigma_e_mv= sqrt(mean(e.^2))*1000;   %manual RMS (to avoid sig process toolbox)
%sigma_e1_mv=rms(e1)*1000;
sigma_e1_mv= sqrt(mean(e1.^2))*1000; %manual RMS (to avoid sig process toolbox)
sigma_de_mv=sqrt(sigma_e_mv^2-sigma_e1_mv^2);
vpeak_mv=max(p)*1000;
v_f_mv=vswing*1000;
v_f_mv_long=vswing_long*1000;   %new 03/09/16
set(handles.sigma_e,'String', sprintf(' %.3g',sigma_e_mv));
set(handles.vp_vf_ratio_short,'String',sprintf(' %.3gmV  %.3gmV  ratio=%.3g',vpeak_mv, v_f_mv, vpeak_mv/v_f_mv) );  %new 03/09/16
set(handles.vp_vf_ratio_long,'String',sprintf(' %.3gmV  %.3gmV  ratio=%.3g',vpeak_mv, v_f_mv_long, vpeak_mv/v_f_mv_long) ); %new 03/09/16
set(handles.sigma_e_delta,'String', sprintf(' %.5g',sigma_de_mv)); %new 03/09/16

%[ hf, f]=td2fdm(params.wf.Data,params.wf.Time,params.UI);
if isfield(params,'ref_meas_file')
    [r, r_linear_fit, r_e, r_Y]=ir_fit_clause_85(params.wf_ref, params.ref_bits, params.UI, params.SPUI, params.n_p, params.d_p);
    params.r=r; params.r_linear_fit=r_linear_fit; params.r_e=r_e; params.r_Y=r_Y;
    dtr=params.wf_ref.Time(2)-params.wf_ref.Time(1);
    t4r=(0:length(r)-1)*dtr;
    hold on
    plot(t4r,r,'-m','disp','Fit (ref)')
    hold off
end
legend 'show'
params.sigma_n_mv=str2num(get(handles.sigma_n,'String'));
params.sndr=20*log10(vpeak_mv/(sqrt(sigma_e_mv^2+params.sigma_n_mv^2)));
params.sndr_delta=20*log10(vpeak_mv/(sqrt(sigma_de_mv^2+params.sigma_n_mv^2)));  %new 03/09/16
set(handles.sndr,'String',sprintf(' %.3g',params.sndr) );
set(handles.sndr_delta,'String',sprintf(' %.3g',params.sndr_delta) );  %new 03/09/16
set(handles.plot_this,'Value',2);
setappdata(0,'params',params);

%% save setup to configuration file
cfgFile.baudselect= get(handles.baudselect,'Value');
cfgFile.baud_rate=get(handles.baud_rate,'String');
cfgFile.d_p=get(handles.d_p,'String');
cfgFile.N_p=get(handles.N_p,'String');
cfgFile.sigma_n=get(handles.addtional_noise,'String');
cfgFile.Nd_p=get(handles.Nd_p,'String');
cfgFile.makefigs=get(handles.makefigs,'Value');
cfgFile.plot_this=get(handles.plot_this,'Value');
cfgFile.meas_file=get(handles.meas_file,'String');
cfgFile.ref_meas_file=get(handles.ref_meas_file,'String');
cfgFile.sbit=get(handles.sbit,'String');
cfgFile.nbits=get(handles.nbits,'String');
cfgFile.trigger_bits=get(handles.trigger_bits,'String');
cfgFile.trigger=get(handles.trigger,'Value');
cfgFile.ref_bits=get(handles.ref_bits,'String');
cfgFile.coding= get(handles.coding,'Value');
cfgFile.apply_ctle= get(handles.apply_ctle,'Value');
cfgFile.apply_ctle_ref= get(handles.apply_ctle_ref,'Value');
cfgFile.ctle_kacdc= get(handles.ctle_kacdc,'String');
cfgFile.ctle_fz= get(handles.ctle_fz,'String');
cfgFile.ctle_fp1= get(handles.ctle_fp1,'String');
cfgFile.ctle_fp2= get(handles.ctle_fp2,'String');
cfgFile.ctle_kacdc_ref= get(handles.ctle_kacdc_ref,'String');
cfgFile.ctle_fz_ref= get(handles.ctle_fz_ref,'String');
cfgFile.ctle_fp1_ref= get(handles.ctle_fp1_ref,'String');
cfgFile.ctle_fp2_ref= get(handles.ctle_fp2_ref,'String');
try
    save('iTX.cfg','cfgFile');  %saving in current DIR, may need to change this
catch
    warning('Unable to save configuration file (.cfg) .....skipping')
end

set(handles.busy_text,'Visible','off')

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
     set(hObject,'BackgroundColor','white');
end

set(hObject, 'String', {'plot(rand(5))', 'plot(sin(1:0.01:25))', 'bar(1:.5:10)', 'plot(membrane)', 'surf(peaks)'});



function meas_file_Callback(hObject, eventdata, handles)
% hObject    handle to meas_file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of meas_file as text
%        str2double(get(hObject,'String')) returns contents of meas_file as a double




% --- Executes during object creation, after setting all properties.
function meas_file_CreateFcn(hObject, eventdata, handles)
% hObject    handle to meas_file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ref_bits_Callback(hObject, eventdata, handles)
% hObject    handle to ref_bits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ref_bits as text
%        str2double(get(hObject,'String')) returns contents of ref_bits as a double


% --- Executes during object creation, after setting all properties.
function ref_bits_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ref_bits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in load_bits.
function load_bits_Callback(hObject, eventdata, handles)
% hObject    handle to load_bits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ~isfield(handles,'path')
    handles.path=[];
end
params=getappdata(0,'params');
[elif,mypath]=uigetfile({[handles.path '*.csv']; [handles.path '*.xls']},'input reference bit pattern ');
params.ref_bits_file=[mypath elif];
[params.path, params.ref_bits_base, params.ref_bits_fileext]=fileparts(params.ref_bits_file);
params.path=mypath;
set(handles.ref_bits,'String',params.ref_bits_file);
h=msgbox(['opening... ' params.ref_bits_file ]);
params.bits=csvread(params.ref_bits_file);
params.bits=(params.bits*2-1);
close(h)
setappdata(0,'params',params);
guidata(hObject, handles);
%
OP.makefigs=get(handles.makefigs,'Value');
if OP.makefigs
   figure
end
stem(params.bits)

% --- Executes on button press in load_meas.
function load_meas_Callback(hObject, eventdata, handles)
% hObject    handle to load_meas (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.busy_text,'Visible','on')  %toggle busy message
pause(0.1);  %pause allows busy text to show

%get path in tx meas edit box to start search for next file.
lastFn = get(handles.meas_file,'String');
if ~isempty(lastFn)
    [searchPth, na1, na2]=fileparts(lastFn);
    pthOld=cd;
    cd(searchPth);
    [elif,mypath]=uigetfile({'*.csv;*.xls;*.xlsx','Excel (*.csv,*.xls,*.xlsx)';'*.mat','Mat (*.mat)'},'Input Measurements ');
    cd(pthOld);
else
    [elif,mypath]=uigetfile({'*.csv;*.xls;*.xlsx','Excel (*.csv,*.xls,*.xlsx)';'*.mat','Mat (*.mat)'},'Input Measurements ');
end
params.meas_file=[mypath elif];
[params.path, params.meas_base, params.meas_fileext]=fileparts(params.meas_file);
params.path=mypath;
set(handles.meas_file,'String',params.meas_file);

%Open File
h=msgbox(['opening... ' params.meas_file ]);
if strcmp(params.meas_fileext, '.mat')    
     try
        load(params.meas_file) % Must have 2 column in wf of time and voltage
     catch
         error('ERROR reading CSV file, file must have 2 columns time and voltage.');
     end
else    
    wf=csvread(params.meas_file);
end
params.wf_orig= wf;  %save copy of original data
close(h)

setappdata(0,'params',params);
%guidata(hObject, handles);
set(handles.busy_text,'Visible','off')

% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1



function UI_Callback(hObject, eventdata, handles)
% hObject    handle to UI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of UI as text
%        str2double(get(hObject,'String')) returns contents of UI as a double


% --- Executes during object creation, after setting all properties.

function UI_CreateFcn(hObject, eventdata, handles)
% hObject    handle to UI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function baud_rate_Callback(hObject, eventdata, handles)
% hObject    handle to baud_rate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of baud_rate as text
%        str2double(get(hObject,'String')) returns contents of baud_rate as a double


% --- Executes during object creation, after setting all properties.
function baud_rate_CreateFcn(hObject, eventdata, handles)
% hObject    handle to baud_rate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function d_p_Callback(hObject, eventdata, handles)
% hObject    handle to d_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of d_p as text
%        str2double(get(hObject,'String')) returns contents of d_p as a double


% --- Executes during object creation, after setting all properties.
function d_p_CreateFcn(hObject, eventdata, handles)
% hObject    handle to d_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function N_p_Callback(hObject, eventdata, handles)
% hObject    handle to N_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of N_p as text
%        str2double(get(hObject,'String')) returns contents of N_p as a double


% --- Executes during object creation, after setting all properties.
function N_p_CreateFcn(hObject, eventdata, handles)
% hObject    handle to N_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in makefigs.
function makefigs_Callback(hObject, eventdata, handles)
% hObject    handle to makefigs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of makefigs



function sigma_e_Callback(hObject, eventdata, handles)
% hObject    handle to sigma_e (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sigma_e as text
%        str2double(get(hObject,'String')) returns contents of sigma_e as a double


% --- Executes during object creation, after setting all properties.
function sigma_e_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sigma_e (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function vp_vf_ratio_short_Callback(hObject, eventdata, handles)
% hObject    handle to vp_vf_ratio_short (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of vp_vf_ratio_short as text
%        str2double(get(hObject,'String')) returns contents of vp_vf_ratio_short as a double


% --- Executes during object creation, after setting all properties.
function vp_vf_ratio_short_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vp_vf_ratio_short (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function vp_vf_ratio_long_Callback(hObject, eventdata, handles)
% hObject    handle to vp_vf_ratio_long (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of vp_vf_ratio_long as text
%        str2double(get(hObject,'String')) returns contents of vp_vf_ratio_long as a double


% --- Executes during object creation, after setting all properties.
function vp_vf_ratio_long_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vp_vf_ratio_long (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in close_figures.
function close_figures_Callback(hObject, eventdata, handles)
% hObject    handle to close_figures (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ch=flipud(get(0, 'children'));
for i=1:length(ch)-1
    close(ch(i))
end;



function nbits_Callback(hObject, eventdata, handles)
% hObject    handle to nbits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nbits as text
%        str2double(get(hObject,'String')) returns contents of nbits as a double


% --- Executes during object creation, after setting all properties.
function nbits_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nbits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Nd_p_Callback(hObject, eventdata, handles)
% hObject    handle to Nd_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Nd_p as text
%        str2double(get(hObject,'String')) returns contents of Nd_p as a double


% --- Executes during object creation, after setting all properties.
function Nd_p_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Nd_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sbit_Callback(hObject, eventdata, handles)
% hObject    handle to sbit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sbit as text
%        str2double(get(hObject,'String')) returns contents of sbit as a double


% --- Executes during object creation, after setting all properties.
function sbit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sbit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function trigger_bits_Callback(hObject, eventdata, handles)
% hObject    handle to trigger_bits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of trigger_bits as text
%        str2double(get(hObject,'String')) returns contents of trigger_bits as a double


% --- Executes during object creation, after setting all properties.
function trigger_bits_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trigger_bits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in trigger.
function trigger_Callback(hObject, eventdata, handles)
% hObject    handle to trigger (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of trigger
if get(hObject,'Value')== 1
    set(handles.trigger_bits,'Enable','on');
else
    set(handles.trigger_bits,'Enable','off');
end

function sigma_e_delta_Callback(hObject, eventdata, handles)
% hObject    handle to sigma_e_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sigma_e_delta as text
%        str2double(get(hObject,'String')) returns contents of sigma_e_delta as a double


% --- Executes during object creation, after setting all properties.
function sigma_e_delta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sigma_e_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in viewlinfit.
function viewlinfit_Callback(hObject, eventdata, handles)
% hObject    handle to viewlinfit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of viewlinfit



function ref_meas_file_Callback(hObject, eventdata, handles)
% hObject    handle to ref_meas_file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ref_meas_file as text
%        str2double(get(hObject,'String')) returns contents of ref_meas_file as a double

% remove for ref file if cleared.
params = getappdata(0,'params');
if ~isempty(params)
    ref_meas_file = get(hObject,'String');
    if isempty(ref_meas_file) 
        if isfield(params,'ref_meas_file')
            params = rmfield(params,'ref_meas_file');
            params = rmfield(params,'ref_path');
            params = rmfield(params,'ref_meas_base');
            params = rmfield(params,'ref_meas_fileext');
            set(handles.find_tap_coef,'Visible','on');
            set(handles.ffe_taps,'Visible','on');
        end
    end
end
setappdata(0,'params',params);


% --- Executes during object creation, after setting all properties.
function ref_meas_file_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ref_meas_file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in load_ref_meas.
function load_ref_meas_Callback(hObject, eventdata, handles)
% hObject    handle to load_ref_meas (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.busy_text,'Visible','on')
pause(0.1);  %pause allows busy text to show
params=getappdata(0,'params');

%Check if previous file carried over, load from same directory
lastFn = get(handles.ref_meas_file,'String');
lastFnMeas = get(handles.meas_file,'String');
if ~isempty(lastFn) || ~isempty(lastFnMeas)
    if ~isempty(lastFn)
        [searchPth, na1, na2]=fileparts(lastFn);
    else
        [searchPth, na1, na2]=fileparts(lastFnMeas);
    end
    pthOld=cd;
    cd(searchPth);
    [elif,mypath]=uigetfile({'*.csv;*.xls;*.xlsx','Excel (*.csv,*.xls,*.xlsx)';'*.mat','Mat (*.mat)'},'Input Measurements ');
    cd(pthOld);
else
    [elif,mypath]=uigetfile({'*.csv;*.xls;*.xlsx','Excel (*.csv,*.xls,*.xlsx)';'*.mat','Mat (*.mat)'},'Input Measurements ');
end
params.ref_meas_file=[mypath elif];
[params.ref_path, params.ref_meas_base, params.ref_meas_fileext]=fileparts(params.ref_meas_file);
params.path=mypath;
set(handles.ref_meas_file,'String',params.ref_meas_file);   

h=msgbox(['opening... ' params.ref_meas_file ]);                      
if strcmp(params.ref_meas_fileext, '.mat')    
     try
        temp=load(params.ref_meas_file); % Must have 2 column in wf of time and voltage
        wf_ref = temp.wf;
     catch
        error('ERROR reading CSV file, file must have 2 columns time and voltage.');
     end
else    
    wf_ref=csvread(params.ref_meas_file);
end
params.wf_ref_orig = wf_ref;
close(h);

setappdata(0,'params',params);
set(handles.find_tap_coef,'Visible','on');
set(handles.ffe_taps,'Visible','on');
guidata(hObject, handles);
set(handles.busy_text,'Visible','off')

% --- Executes on button press in find_tap_coef.
function find_tap_coef_Callback(hObject, eventdata, handles)
% hObject    handle to find_tap_coef (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
params=getappdata(0,'params');
[ C p pm ] = find_taps( params.r, params.p, params.SPUI, params.n_p );
set(handles.ffe_taps,'String', sprintf('[ %.3g  %.3g  %.3g  ]',round(C,3) ));
OP.makefigs=get(handles.makefigs,'Value');
if OP.makefigs
    figure
end
plot(p)
hold on
plot(pm)

function ffe_taps_Callback(hObject, eventdata, handles)
% hObject    handle to ffe_taps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ffe_taps as text
%        str2double(get(hObject,'String')) returns contents of ffe_taps as a double


% --- Executes during object creation, after setting all properties.
function ffe_taps_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ffe_taps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in plot_this.
function plot_this_Callback(hObject, eventdata, handles)
% hObject    handle to plot_this (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns plot_this contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plot_this
params=getappdata(0,'params');
OP=getappdata(0,'OP');
OP.makefigs=get(handles.makefigs,'Value');
if OP.makefigs
    figure
end
switch get(handles.plot_this,'Value')
    case 1  %plot bit pattern and measurement
        hold off
        plot(params.wf)
        hold on
        if params.apply_ctle && params.plot_ctle
            plot(params.wfctle,'-b')
        end
        plot(params.patwfm,'-r')
        %add room for risetime info
        yAx= get(gca,'YLim');
        ylim([yAx(1) yAx(2)*1.15])
%         if params.coding==1; 
%             text(max(params.wf.time)*0.5,yAx(2)*1.05,params.tr.trStr); 
%         end;
        hold off
        
    case 2 %plot fit
        hold off
        p=params.p;
        p1=params.p1;
        dt=params.wf.Time(2)-params.wf.Time(1);
        t4p=(0:length(p)-1)*dt;
        t4p1=(0:length(p1)-1)*dt;
        plot(t4p1,p1,'-b', 'disp','Full PR')
        hold on
        plot(t4p,p,'-r','disp','Fit')
        cur=find(p == max(p));
        %stem(t4p(cur+params.SPUI*(-params.d_p:params.n_p-params.d_p-1)),p(cur+params.SPUI*(-params.d_p:params.n_p-params.d_p-1)))
        stem(t4p(cur+params.SPUI*(-params.d_p:params.n_p-1-params.d_p)),p(cur+params.SPUI*(-params.d_p:params.n_p-1-params.d_p)),'disp','N_p')                
        if isfield(params,'ref_meas_file')            
            dtr=params.wf_ref.Time(2)-params.wf_ref.Time(1);
            t4r=(0:length(params.r)-1)*dtr;
            plot(t4r,params.r,'-m', 'disp','Fit (ref)')   
        end
        legend 'show'
        grid on
        hold off
        
    case 3 %plot measurement, linear fit, error
        hold off
        Y=params.Y;Y1=params.Y1;e=params.e;
        plot(Y(:),'disp','Y')
        hold on
        plot(params.linear_fit,'disp','linear fit')
        plot(e,'disp','e')
        hold off
        
    case 4 %plot eye diagram
        quickeye( params.wf, params.SPUI, -2 );
        
    case 5 % fit IL freq response
        hold off
        p=params.p;
        p1=params.p1;
        dt=params.wf.Time(2)-params.wf.Time(1);
        t4p=(0:length(p)-1)*dt;
        t4p1=(0:length(p1)-1)*dt;
        f=0:1/max(t4p1):0.5/dt;
        %prr=sinc(f*params.UI);
        prr=sin(f*params.UI*pi)./(f*params.UI*pi); %removing sinc function to avoid using sig proc toolbox
        prr(find(isnan(prr)))=1; %fixing divide by 0 issue with manual sinc.
        b=repmat([1 zeros(1,params.SPUI-1)],1,params.nd_p);
        s=filter(b,1, p1 );
        vswing=max(s);
        fd2=fft(p1);
        fd2=fd2(1:floor(length(fd2)/2));
        %         plot(f,db(abs(prr(1:length(f)))))
        f75=find(f >= params.baud_rate*.75,1,'first');
        fnq=find(f >= params.baud_rate*.5,1,'first');
        %ILest=db(abs(fd2/vswing/params.SPUI))-db(abs(prr)).';
        ILest=20.*log10(abs(fd2/vswing/params.SPUI))  -   20.*log10(abs(prr)).';  %removing db function to avoid using sig proc toolbox
        fqn_str=sprintf('%3.2g dB', ILest(fnq));
        plot(f(1:f75),ILest(1:f75),'disp','IL estimate')
        hold on
        stem(f(fnq),ILest(fnq),'disp',fqn_str)
        grid on
        legend 'show'
        hold off
        
    case 6
        
        
end
grid on

% --- Executes during object creation, after setting all properties.
function plot_this_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_this (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in baudselect.
function baudselect_Callback(hObject, eventdata, handles)
% hObject    handle to baudselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns baudselect contents as cell array
%        contents{get(hObject,'Value')} returns selected item from baudselect

switch get(handles.baudselect,'Value')
    case 1
        baudrate=25e9*66/64;
        codingVal =1;
    case 2
        baudrate=10e9*66/64;
        codingVal =1;
    case 3
        baudrate=5e9*66/64;
        codingVal =1;
    case 4
        baudrate=2.5e9*10/8;
        codingVal =1;
    case 5
        codingVal =1;
    case 6
        baudrate=16e9;
        codingVal =1;
    case 7
        baudrate=8e9;
        codingVal =1;
    case 8
        baudrate=5e9;
        codingVal =1;
end
set(handles.baud_rate,'String', sprintf(' %.5g',baudrate));
set(handles.coding,'Value',codingVal);

% --- Executes during object creation, after setting all properties.
function baudselect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to baudselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sndr_Callback(hObject, eventdata, handles)
% hObject    handle to sndr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sndr as text
%        str2double(get(hObject,'String')) returns contents of sndr as a double


% --- Executes during object creation, after setting all properties.
function sndr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sndr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function addtional_noise_Callback(hObject, eventdata, handles)
% hObject    handle to addtional_noise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of addtional_noise as text
%        str2double(get(hObject,'String')) returns contents of addtional_noise as a double


% --- Executes during object creation, after setting all properties.
function addtional_noise_CreateFcn(hObject, eventdata, handles)
% hObject    handle to addtional_noise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in coding.
function coding_Callback(hObject, eventdata, handles)
% hObject    handle to coding (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns coding contents as cell array
%        contents{get(hObject,'Value')} returns selected item from coding


% --- Executes during object creation, after setting all properties.
function coding_CreateFcn(hObject, eventdata, handles)
% hObject    handle to coding (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_fp2_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_fp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_fp2 as text
%        str2double(get(hObject,'String')) returns contents of ctle_fp2 as a double


% --- Executes during object creation, after setting all properties.
function ctle_fp2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_fp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_fz_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_fz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_fz as text
%        str2double(get(hObject,'String')) returns contents of ctle_fz as a double


% --- Executes during object creation, after setting all properties.
function ctle_fz_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_fz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_fp1_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_fp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_fp1 as text
%        str2double(get(hObject,'String')) returns contents of ctle_fp1 as a double


% --- Executes during object creation, after setting all properties.
function ctle_fp1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_fp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_kacdc_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_kacdc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_kacdc as text
%        str2double(get(hObject,'String')) returns contents of ctle_kacdc as a double


% --- Executes during object creation, after setting all properties.
function ctle_kacdc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_kacdc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in apply_ctle.
function apply_ctle_Callback(hObject, eventdata, handles)
% hObject    handle to apply_ctle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% if get(hObject,'Value')
%     params = getappdata(0,'params');
%     
%     %% Tx Meas
%     %Find out if any measurements have been loaded yet. 
%     runCTLE=0;
%     if ~isempty(params)
%         runCTLE=1;    
%     end
%     
%     %Read Current Tx Meas Values
%     params.plot_ctle = get(handles.plot_ctle,'Value');
%     ctle_kacdc = str2num(get(handles.ctle_kacdc,'String'));
%     ctle_fz = str2num(get(handles.ctle_fz,'String'));
%     ctle_fp1 = str2num(get(handles.ctle_fp1,'String'));
%     ctle_fp2 = str2num(get(handles.ctle_fp2,'String'));
%     ctle_kacdc_ref = str2num(get(handles.ctle_kacdc_ref,'String'));
%     ctle_fz_ref = str2num(get(handles.ctle_fz_ref,'String'));
%     ctle_fp1_ref = str2num(get(handles.ctle_fp1_ref,'String'));
%     ctle_fp2_ref = str2num(get(handles.ctle_fp2_ref,'String'));
%     
%     %Check if ctle values have changed  (run if true, or no previous values exist)
%     if isfield(params,'ctle_kacdc') && runCTLE==1  %make sure ctle has been run before
%         ctleVals = [ ctle_kacdc ctle_fz ctle_fp1 ctle_fp2];
%         ctleParamVals = [ params.ctle_kacdc params.ctle_fz params.ctle_fp1 params.ctle_fp2];        
%         if sum(ctleParamVals==ctleVals) == 4
%             %no change, do not run CTLE
%             runCTLE=0;
%         end
%     end
%     
%     if runCTLE
%         params.ctle_kacdc = ctle_kacdc;
%         params.ctle_fz = ctle_fz;
%         params.ctle_fp1 = ctle_fp1;
%         params.ctle_fp2 = ctle_fp2;
%         %Reset wf
%         wf = params.wf_orig;
%         OP.trigger=get(handles.trigger,'Value');
%         OP.makefigs=get(handles.makefigs,'Value');
%         
%         %Fit bit pattern w. new CTLE
%         params = fitpat_txmeas(params, wf, OP);
%         setappdata(0,'params',params);        
%         set(handles.plot_this,'Value',1);        
%     end
%     
%     %% Tx Ref Meas
%     runCTLEref=0;
%     if isfield(params,'ref_meas_file') && ~isempty(params.ref_meas_file)
%         runCTLEref=1;
%     end
%     %Check if ctle values have changed  (run if true, or no previous values exist)
%     if isfield(params,'ctle_kacdc_ref') && runCTLEref==1  %make sure ctle has been run before
%         ctleVals = [ ctle_kacdc_ref ctle_fz_ref ctle_fp1_ref ctle_fp2_ref];
%         ctleParamVals = [ params.ctle_kacdc_ref params.ctle_fz_ref params.ctle_fp1_ref params.ctle_fp2_ref];        
%         if sum(ctleParamVals==ctleVals) == 4
%             %no change, do not run CTLE
%             runCTLEref=0;
%         end
%     end
%     if runCTLEref
%         params.ctle_kacdc_ref = ctle_kacdc_ref;
%         params.ctle_fz_ref = ctle_fz_ref;
%         params.ctle_fp1_ref = ctle_fp1_ref;
%         params.ctle_fp2_ref = ctle_fp2_ref;
%         %Reset wf
%         wf_ref = params.wf_ref_orig;
%         OP.trigger=get(handles.trigger,'Value');
%         OP.makefigs=get(handles.makefigs,'Value');
%         %Fit bit pattern w. new CTLE
%         params = fitpat_txmeas(params, wf_ref, OP);
%         setappdata(0,'params',params);        
%         set(handles.plot_this,'Value',1);        
%     end
%     if runCTLE || runCTLEref
%         TxFt('fit_Callback',gcbo,[],guidata(gcbo))
%     end
% else
%    %Remove CTLE
%    
%     
%     
% end



function sndr_delta_Callback(hObject, eventdata, handles)
% hObject    handle to sndr_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sndr_delta as text
%        str2double(get(hObject,'String')) returns contents of sndr_delta as a double


% --- Executes during object creation, after setting all properties.
function sndr_delta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sndr_delta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_kacdc_ref_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_kacdc_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_kacdc_ref as text
%        str2double(get(hObject,'String')) returns contents of ctle_kacdc_ref as a double


% --- Executes during object creation, after setting all properties.
function ctle_kacdc_ref_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_kacdc_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_fz_ref_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_fz_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_fz_ref as text
%        str2double(get(hObject,'String')) returns contents of ctle_fz_ref as a double


% --- Executes during object creation, after setting all properties.
function ctle_fz_ref_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_fz_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_fp1_ref_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_fp1_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_fp1_ref as text
%        str2double(get(hObject,'String')) returns contents of ctle_fp1_ref as a double


% --- Executes during object creation, after setting all properties.
function ctle_fp1_ref_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_fp1_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ctle_fp2_ref_Callback(hObject, eventdata, handles)
% hObject    handle to ctle_fp2_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ctle_fp2_ref as text
%        str2double(get(hObject,'String')) returns contents of ctle_fp2_ref as a double


% --- Executes during object creation, after setting all properties.
function ctle_fp2_ref_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ctle_fp2_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function tbd_noise_Callback(hObject, eventdata, handles)
% hObject    handle to addtional_noise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of addtional_noise as text
%        str2double(get(hObject,'String')) returns contents of addtional_noise as a double


% --- Executes during object creation, after setting all properties.
function tbd_noise_CreateFcn(hObject, eventdata, handles)
% hObject    handle to addtional_noise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in plot_ctle.
function plot_ctle_Callback(hObject, eventdata, handles)
% hObject    handle to plot_ctle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of plot_ctle
params=getappdata(0,'params');
if ~isempty(params)
    params.plot_ctle = get(hObject,'Value');
end
setappdata(0,'params',params);    

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);
setappdata(0,'params',[]);  %empty param variable


% --- Executes on button press in apply_ctle_ref.
function apply_ctle_ref_Callback(hObject, eventdata, handles)
% hObject    handle to apply_ctle_ref (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of apply_ctle_ref



function sigma_n_Callback(hObject, eventdata, handles)
% hObject    handle to sigma_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sigma_n as text
%        str2double(get(hObject,'String')) returns contents of sigma_n as a double


% --- Executes during object creation, after setting all properties.
function sigma_n_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sigma_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
