function [wf_out] = add_CTLE(fb,db_DCgain)
[elif,mypath]=uigetfile({['*.csv']; ['*.xls']; ['*.xlsx'] },'input time voltage measuremenet');
A=xlsread([mypath elif]);
wf_in=timeseries(A(:,2),A(:,1));
wf_out=TD_CTLE(wf_in.Data, fb, fb/4, fb/4, fb, db_DCgain, 32);
plot(wf_in.Time,wf_out)
hold on
plot(wf_in)

function [impulse_response, p1_ctle, p2_ctle, z_ctle] = TD_CTLE(ir_in, fb, f_z, f_p1, f_p2, kacdc_dB, oversampling)
%% Equation 93A-22 implemented in z-space and applied to the impulse response.
p1_ctle = -2*pi*f_p1;
p2_ctle = -2*pi*f_p2;
z_ctle = -2*pi*f_z*10^(kacdc_dB/20);
k_ctle = -p2_ctle;
bilinear_fs = 2*fb*oversampling;
p2d = (1+p2_ctle/bilinear_fs)./(1-p2_ctle/bilinear_fs);
p1d = (1+p1_ctle/bilinear_fs)./(1-p1_ctle/bilinear_fs);
zd = (1+z_ctle/bilinear_fs)./(1-z_ctle/bilinear_fs);
kd = (bilinear_fs-z_ctle)/((bilinear_fs-p1_ctle)*(bilinear_fs-p2_ctle));
B_filt =k_ctle*kd*poly([zd, -1]);
A_filt=poly([p1d, p2d]);
impulse_response=filter(B_filt,A_filt,ir_in);