
function [params] = fitpat_txmeas(params, wf, OP)
   
    %Interpolate measured waveform
    params.wf=timeseries(wf(:,2),wf(:,1));
    dt=params.UI/params.SPUI;
    norm_time=(params.wf.Time-params.wf.Time(1));   %added 03/09/16
    num_new_samples=floor(norm_time(end)/dt);       %added 03/09/16    
    y = interp1(norm_time, params.wf.Data,(0:num_new_samples-1)*dt , 'linear','extrap'); %added 03/09/16
    params.wf=timeseries(y,(0:num_new_samples-1)*dt);     
   
    %%% process data 
    if OP.makefigs
       figure
    end
    % find bits
    dt=params.wf.time(2)-params.wf.time(1);
    N=round(params.UI/dt);
    if params.coding == 2
        %Do PAM-4
        if params.apply_ctle
            [params.wf, params.bits, params.patwfm, params.wfctle]=find_bitpat_pam4(params.wf,N,0,params.UI,params.ctle_kacdc,params.ctle_fz,params.ctle_fp1,params.ctle_fp2);
        else
            [params.wf, params.bits, params.patwfm]=find_bitpat_pam4(params.wf,N,0,params.UI);
        end
    else
        if params.apply_ctle
            [params.wf, params.bits, params.patwfm, params.wfctle]=find_bitpat(params.wf,N,0,params.UI,params.ctle_kacdc,params.ctle_fz,params.ctle_fp1,params.ctle_fp2);
        else
            [params.wf, params.bits, params.patwfm]=find_bitpat(params.wf,N,0,params.UI);
        end
    end

    % trim
    start_trim_bit=params.sbit;
    if OP.trigger
        a=num2str((params.bits+1)/2);
        b=num2str(params.trigger_bits);
        a=a(a~=' ');
        b=b(b~=' ');
        indexes=strfind(a,b);
        if isempty(indexes)
            start_trim_bit=params.sbit;
        else
            start_trim_bit=params.sbit+indexes(1);
        end
    end
    t_start_trim=(start_trim_bit-1)*params.UI;
    t_end_trim=min((start_trim_bit+params.nbits-1)*params.UI,params.wf.time(end) );
    %params.wf=timeseries(wf(:,2),wf(:,1));

    isrt=find(params.wf.Time >= t_start_trim ,1);
    iendt=find(params.wf.Time >= t_end_trim ,1);
    clear wf
    wf(:,1)=params.wf.Time(isrt:iendt);
    wf(:,2)=params.wf.Data(isrt:iendt);
    params.wf1=timeseries(wf(:,2),wf(:,1));
    if params.coding == 2
        %Do PAM-4
        if params.apply_ctle
            [params.wf, params.bits, params.patwfm, params.wfctle]=find_bitpat_pam4(params.wf1,N,0,params.UI,params.ctle_kacdc,params.ctle_fz,params.ctle_fp1,params.ctle_fp2);
        else
            [params.wf, params.bits, params.patwfm]=find_bitpat_pam4(params.wf1,N,0,params.UI);
        end
    else
        if params.apply_ctle
            [params.wf, params.bits, params.patwfm, params.wfctle]=find_bitpat(params.wf1,N,0,params.UI,params.ctle_kacdc,params.ctle_fz,params.ctle_fp1,params.ctle_fp2);
        else
            [params.wf, params.bits, params.patwfm]=find_bitpat(params.wf1,N,0,params.UI);
        end
    end
    %find risetime of measured data
%     if params.coding==1  %only calc risetime for NRZ (for now)
%         stLvls = statelevels(params.wf.data);
%         [rt ft]= find_risetime(params.wf,params.patwfm,params.SPUI,stLvls);
%         if ~isempty(rt)
%             tr.mean = mean(rt)*1e12;
%             tr.min = min(rt)*1e12;
%             tr.max = max(rt)*1e12;
%             tr.min_str=sprintf('%.3g',tr.min);
%             tr.mean_str=sprintf('%.3g',tr.mean);
%             tr.max_str=sprintf('%.3g',tr.max);
%             tr.trStr = ['Risetime: ' tr.min_str 'ps/' tr.mean_str 'ps/' tr.max_str 'ps (min/mean/max)'];
%         else
%             tr.trStr='';
%         end
%         params.tr= tr;
%     end
    %plot data
    hold off
    plot(params.wf)
    hold on
    if params.apply_ctle && params.plot_ctle
        plot(params.wfctle,'-b')
    end
    if length(params.wf.data) > length(params.patwfm.data)
         params.wf=timeseries(params.wf.data(1:length(params.patwfm.data)), params.wf.time(1:length(params.patwfm.data)));
    elseif length(params.wf.data) < length(params.patwfm.data)
         params.patwfm=timeseries(params.patwfm.data(1:length(params.wf.data)), params.patwfm.time(1:length(params.wf.data)));
    end
    [c,lags]=xcorr(params.wf.data,squeeze(params.patwfm.data));
    [~,blInd]= max(abs(c));
    bestlag=lags(blInd);
    %params.patwfm=timeseries(params.patwfm.data(1-bestlag:length(params.wf.data)), params.patwfm.time(1-bestlag:length(params.wf.data)));
    %params.wf=timeseries(params.wf.data(1:end+bestlag), params.wf.time(1:end+bestlag));
    if bestlag < 0
        params.patwfm=timeseries(params.patwfm.data(-bestlag+1:length(params.wf.data)), params.patwfm.time(1:length(params.wf.data)+bestlag)); %shift
        params.wf=timeseries(params.wf.data(1:end+bestlag), params.wf.time(1:end+bestlag)); %trim
    elseif bestlag > 0
        params.patwfm=timeseries(params.patwfm.data(1:end-bestlag), params.patwfm.time(1:end-bestlag)); %trim
        params.wf=timeseries(params.wf.data(bestlag+1:end), params.wf.time(1:end-bestlag));        %shift
    end
    params.Rqrd=corrcoef(params.wf.data,params.patwfm.data);
    plot(params.patwfm,'-r','disp',sprintf('Signal (R_s_q_r_d= %.2g)',params.Rqrd(2,1)))
    legend show
    %add room for risetime info
    yAx= get(gca,'YLim');
    ylim([yAx(1) yAx(2)*1.15])
    %if params.coding==1; text(max(params.wf.time)*0.5,yAx(2)*1.05,tr.trStr); end;
    hold off

    