function [params] = fitpat_txrefmeas(params, wf_ref, OP)

params.wf_ref=timeseries(wf_ref(:,2),wf_ref(:,1));
dt=params.UI/params.SPUI;
%num_new_samples=floor((params.wf_ref.Time(end)-params.wf_ref.Time(1))/params.UI);
norm_time=(params.wf_ref.Time-params.wf_ref.Time(1));   %added 03/09/16
num_new_samples=floor(norm_time(end)/dt);       %added 03/09/16    
y = interp1(norm_time, params.wf_ref.Data,(0:num_new_samples-1)*dt , 'linear','extrap'); %added 03/09/16    
%y = interp1(params.wf_ref.Time-params.wf_ref.Time(1), params.wf_ref.Data,(0:num_new_samples-1)*dt , 'linear','extrap');
params.wf_ref=timeseries(y,(0:num_new_samples-1)*dt);


if OP.makefigs
    figure
end
% find bits
dt=params.wf_ref.time(2)-params.wf_ref.time(1);
N=round(params.UI/dt);
if params.coding == 2
    %PAM-4
    if params.apply_ctle_ref
        [params.wf_ref, params.ref_bits, patwf_refm, params.wf_refctle]=find_bitpat_pam4(params.wf_ref,N,0,params.UI,params.ctle_kacdc_ref,params.ctle_fz_ref,params.ctle_fp1_ref,params.ctle_fp2_ref);
    else
        [params.wf_ref, params.ref_bits, patwf_refm]=find_bitpat_pam4(params.wf_ref,N,0,params.UI);
    end
else   
    if params.apply_ctle_ref
        [params.wf_ref, params.ref_bits, patwf_refm, params.wf_refctle]=find_bitpat(params.wf_ref,N,0,params.UI,params.ctle_kacdc_ref,params.ctle_fz_ref,params.ctle_fp1_ref,params.ctle_fp2_ref);
    else
        [params.wf_ref, params.ref_bits, patwf_refm]=find_bitpat(params.wf_ref,N,0,params.UI);
    end
end
% trim
start_trim_bit=params.sbit;
if OP.trigger
    a=num2str((params.ref_bits+1)/2);
    b=num2str(params.trigger_bits);
    a=a(a~=' ');
    b=b(b~=' ');
    indexes=strfind(a,b);
    if isempty(indexes)
        start_trim_bit=params.sbit;
    else
        start_trim_bit=params.sbit+indexes(1);
    end
end
t_start_trim=(start_trim_bit-1)*params.UI;
t_end_trim=min((start_trim_bit+params.nbits-1)*params.UI,params.wf_ref.time(end) );
% params.wf_ref=timeseries(wf_ref(:,2),wf_ref(:,1));

isrt=find(params.wf_ref.Time >= t_start_trim ,1);
iendt=find(params.wf_ref.Time >= t_end_trim ,1);
clear wf_ref
wf_ref(:,1)=params.wf_ref.Time(isrt:iendt);
wf_ref(:,2)=params.wf_ref.Data(isrt:iendt);
params.wf_ref1=timeseries(wf_ref(:,2),wf_ref(:,1));
if params.coding == 2
    %PAM-4
    if params.apply_ctle_ref
        [params.wf_ref, params.ref_bits, params.patwf_refm]=find_bitpat_pam4(params.wf_ref1,N,0,params.UI,params.ctle_kacdc_ref,params.ctle_fz_ref,params.ctle_fp1_ref,params.ctle_fp2_ref);
    else
        [params.wf_ref, params.ref_bits, params.patwf_refm]=find_bitpat_pam4(params.wf_ref1,N,0,params.UI);
    end        
else
    if params.apply_ctle_ref
        [params.wf_ref, params.ref_bits, params.patwf_refm]=find_bitpat(params.wf_ref1,N,0,params.UI,params.ctle_kacdc_ref,params.ctle_fz_ref,params.ctle_fp1_ref,params.ctle_fp2_ref);
    else
        [params.wf_ref, params.ref_bits, params.patwf_refm]=find_bitpat(params.wf_ref1,N,0,params.UI);
    end 
end
if length(params.wf_ref.data) > length(params.patwf_refm.data)
    params.wf_ref=timeseries(params.wf_ref.data(1:length(params.patwf_refm.data)), params.wf_ref.time(1:length(params.patwf_refm.data)));
elseif length(params.wf_ref.data) < length(params.patwf_refm.data)
    params.patwf_refm=timeseries(params.patwf_refm.data(1:length(params.wf_ref.data)), params.patwf_refm.time(1:length(params.wf_ref.data)));
end

[c,lags]=xcorr(params.wf_ref.data,params.patwf_refm.data);
[~,blInd]= max(abs(c));
bestlag=lags(blInd);
% params.patwf_refm=timeseries(params.patwf_refm.data(1-bestlag:length(params.wf_ref.data)), params.patwf_refm.time(1-bestlag:length(params.wf_ref.data)));
% params.wf_ref=timeseries(params.wf_ref.data(1:end+bestlag), params.wf_ref.time(1:end+bestlag));
if bestlag < 0
    params.patwf_refm=timeseries(params.patwf_refm.data(-bestlag+1:length(params.wf_ref.data)), params.patwf_refm.time(1:length(params.wf_ref.data)+bestlag)); %shift
    params.wf_ref=timeseries(params.wf_ref.data(1:end+bestlag), params.wf_ref.time(1:end+bestlag)); %trim
elseif bestlag > 0
    params.patwf_refm=timeseries(params.patwf_refm.data(1:end-bestlag), params.patwf_refm.time(1:end-bestlag)); %trim
    params.wf_ref=timeseries(params.wf_ref.data(bestlag+1:end), params.wf_ref.time(1:end-bestlag));        %shift
end
params.Rqrd_Ref=corrcoef(params.wf_ref.data,params.patwf_refm.data);
hold off
plot(params.wf_ref)
hold on
plot(params.patwf_refm,'-r','disp',sprintf('Signal (R_s_q_r_d= %.2g)',params.Rqrd_Ref(2,1)))
hold off
legend show

